#!/usr/local/bin/perl
##############################################################
# Perl to markup UB files with links to index files 
# 
# Execute at command prompt --> D:\>perl Temp/David/UpdateUBHTML.pl
##############################################################
# $`-unmatched preceding text; $'-unmatched following; text $&-entire pattern

 $Dir_root   = "C:/websites/urantiabook_org/newbook/";
 $Input_dir  = $Dir_root . "UB";	 # Directory of input UB files
 $Output_dir = $Dir_root . "newUB";	 # Directory for output of new UB files
 $MakeListOP = $Dir_root . "newindex/ListOfNames.txt";  # File output by MakeList.pl
 $RelRef = "../newindex/";	# Relative dir reference from new UB to new index files

 print("\n********************************************************************\n");
 print("* UpdateUBHTML searches each UB file in a directory for a match from\n");
 print("* the list of words produced by MakeList.pl. Word matches are updated\n"); 
 print("* with a link to the appropriate index file.\n");
 print("********************************************************************\n\n");
 print("Press Enter to begin...");
 $a = <STDIN>;

 opendir(UBIP, "$Input_dir") ||
   die ("1. Can't open UB input directory: $Input_dir");
 opendir(UBOP, "$Output_dir") ||
   die ("1. Can't open new UB output directory: $Output_dir");
 open ("LINKS", "$MakeListOP") ||
   die ("Can't open input list file: $MakeListOP");

#
# Get the list for names of links
#
 @ListNames = <LINKS>;			# Read list of names into array

#
# Read each file in the directory of UB files, skipping the . files
#
while ($in_file = readdir(UBIP)) {
  next if($in_file eq "." | $in_file eq "..");
  @filearray[$cnt] = $in_file;
  $cnt++;
}
@filearray = sort(@filearray);		# Sorted list of UB file names

#
# Read UB files looking for words/phrases to link to index file
#
foreach $UBfile (@filearray) {
  $ReadUB = $Input_dir . "/" . $UBfile;
  open ("UBIP", "$ReadUB") ||
    die ("2. Can't open UB input file:  $ReadUB");
  $WriteUB = ">" . $Output_dir . "/" . $UBfile;
  open ("UBOP", "$WriteUB") ||
    die ("2. Can't open new UB output file: $FOut1");
  $size = -s $ReadUB;
  read (UBIP, $longline, $size);  # Read UB file into one record
  print ("$ReadUB\n");

  $longline =~ /<hr /i;
  $head = $`;				# Unmatched preceding text
  $longline = $';			# unmatched following text
  $longline =~ /index.html/i;
  $longline = $`;			# Unmatched preceding text
  $tail = $';				# unmatched following text

  foreach $linkname (@ListNames) {
    @array = split(/QQ/,$linkname);
    $fname = $array[0];
    $fname = $RelRef . $fname;
    $lname = $array[1];
    $lwords = $array[2];
    chop ($lwords);
    $longline =~ s/($lwords[ \.\,\"\?\:\;])/\n\<A HREF="$fname\#$lname"\>$1\<\/A\>\n/g;
  }
  $newline = $head . "<hr " . $longline . "index.html" . $tail;
  &write_record("UBOP", $newline);
}
 print ("\nFiles from $Input_dir updated and written to \n\t$Output_dir\n");

############################################################
# Subroutines
############################################################
sub write_record {
  local ($filevar,$x) = @_;
  $cnt_out++;
  print $filevar($x);
#  print ("Op: $x");
  $lpcnt++;
}
